//########################
//InDesignCS3で繰り返し複製します。
//基本機能と違うのはX方向Y方向同時に複製します。
//訂正シール用にトンボをつけることと
//デフォルト値の移動量にオブジェクトのサイズが入り
//移動回数はページサイズ/オブジェクトサイズを四捨五入した値がはいるようになっています。
//つまり、何も設定せずに作成してもそこそこの結果が得られるという事です。
//たけうちとおる
//########################

//ダイアログ表示のおまじない
app.scriptPreferences.userInteractionLevel=1699311169;

main();

function main(){
	if (app.documents.length == 0){
		alert("ドキュメントを開いてください");
		return;
	}
	if (app.selection.length == 0){
		alert("オブジェクトを選択してください");
		return;
	}
	var selbounds = getselectedbounds(app.selection);
	var pagebounds = app.activeWindow.activePage.bounds;
	var dupWidth = pagebounds[3]-selbounds[1];
	var motoXcount = Math.round(dupWidth/(selbounds[3]-selbounds[1]));
	var dupheight = pagebounds[2]-selbounds[0];
	var motoYcount = Math.round(dupheight/(selbounds[2]-selbounds[0]));
	//ダイアログを作成する
	myDialog = app.dialogs.add({name:"訂正シール複製"});
	with(myDialog){
		with(dialogColumns.add()){
			with(borderPanels.add()){
				staticTexts.add({staticLabel:"選択されたオブジェクトを繰り返し複製します（単位はドキュメント依存）"});
			}
			with(borderPanels.add()){
					var Listpercent = new Array( "1","2", "3", "4", "5", "6", "7", "8", "9", "10");
					staticTexts.add({staticLabel:"繰り返し回数"});
					var xcount = integerComboboxes.add({editValue:motoXcount,minimumValue:0,maximumValue:255,stringList:Listpercent});
					staticTexts.add({staticLabel:"水平方向オフセット"});
					var xmove = realEditboxes.add({editValue:selbounds[3]-selbounds[1],minimumValue:0,maximumValue:2000});
			}
			with(borderPanels.add()){
					staticTexts.add({staticLabel:"繰り返し回数"});
					var ycount = integerComboboxes.add({editValue:motoYcount,minimumValue:0,maximumValue:255,stringList:Listpercent});
					staticTexts.add({staticLabel:"垂直方向オフセット"});
					var ymove = realEditboxes.add({editValue:selbounds[2]-selbounds[0],minimumValue:0,maximumValue:2000});
			}
			with(borderPanels.add()){
					var tomboflg = checkboxControls.add({staticLabel:"トンボも作成", checkedState:true})
			}
		}
	}
	var myReturn = myDialog.show();
	//ここから処理を行う
	if (myReturn == true){
		var xmovevalue = xmove.editValue;
		var xcountvalue = xcount.editValue;
		var ymovevalue = ymove.editValue;
		var ycountvalue = ycount.editValue;
		var mytomboflg = tomboflg.checkedState;
		myDialog.destroy();
		makeTombo(app.selection,xmovevalue,xcountvalue,ymovevalue,ycountvalue,mytomboflg,selbounds);
		indd_dup_selected_box(app.selection,xmovevalue,xcountvalue,ymovevalue,ycountvalue);
	}
	else{
		myDialog.destroy();
	}
}

function indd_dup_selected_box(motoobj,xmovevalue,xcountvalue,ymovevalue,ycountvalue){
	for(var N = 0; N < motoobj.length;N++){
		var moto_bounds = motoobj[N].visibleBounds;
		var newx_pos = moto_bounds[1] ;
		for(var X = 0;X < xcountvalue;X++){
			var newy_pos = moto_bounds[0];
			for(var Y = 0;Y < ycountvalue;Y++){
				if(X == 0 && Y == 0){}else{
					var newobj = motoobj[N].duplicate();
					newobj.move([newx_pos,newy_pos]);
				}
				newy_pos = newy_pos + ymovevalue;
			}
			newx_pos = newx_pos + xmovevalue;
		}
	}
}

function getselectedbounds(motoobj){
	var moto_bounds = motoobj[0].visibleBounds;
	var orgy2 = moto_bounds[0];
	var orgx2 = moto_bounds[1];
	var orgy1 = moto_bounds[2] ;
	var orgx1 = moto_bounds[3] ;
	for(var N = 0; N < motoobj.length;N++){
		var moto_bounds = motoobj[N].visibleBounds;
		var newy1_pos = moto_bounds[0] ;
		var newx1_pos = moto_bounds[1] ;
		var newy2_pos = moto_bounds[2] ;
		var newx2_pos = moto_bounds[3] ;
		if(newy1_pos < orgy1){orgy1 = newy1_pos;}
		if(newx1_pos < orgx1){orgx1 = newx1_pos;}
		if(newy2_pos > orgy2){orgy2 = newy2_pos;}
		if(newx2_pos > orgx2){orgx2 = newx2_pos;}
	}
	return Array(orgy1,orgx1,orgy2,orgx2);
}

function makeTombo(motoobj,xmovevalue,xcountvalue,ymovevalue,ycountvalue,mytomboflg,selbounds){
	if(! mytomboflg){
		return;
	}
	var lineW=0.05;
	var myAry=new Array();
	var myAryCount = 0;
	var myRegistrationColor = app.activeDocument.colors.item("Registration");

	var orgy = selbounds[0] ;
	var orgx =  selbounds[1] ;
	var orgy2 =  selbounds[2] ;
	var orgx2 =  selbounds[3] ;
	var orgw = orgx2 - orgx;
	var orgh = orgy2 - orgy;
	var endx = orgx2 + (xmovevalue * (xcountvalue-1));
	var endy = orgy2 + (ymovevalue * (ycountvalue-1));
	
	//■■■■ここから縦の線を引いていく■■■■
	var Y1 = orgy - 13;
	var Y2 = orgy - 3;
	var Y1e = endy + 13;
	var Y2e = endy + 3;
	for(var X = 0;X < xcountvalue ;X++){
		var X1 = orgx + (xmovevalue * X);
		//上の線
		myAry[myAryCount] = drowLine(X1,X1,Y1,Y2,lineW,myRegistrationColor);
		myAryCount++;
		//下の線
		myAry[myAryCount] = drowLine(X1,X1,Y1e,Y2e,lineW,myRegistrationColor);
		myAryCount++;
		//もし選択の幅と移動量が違うなら線をもう一本
		if(orgw != xmovevalue){
			//上の線
			myAry[myAryCount] = drowLine(X1+orgw,X1+orgw,Y1,Y2,lineW,myRegistrationColor);
			myAryCount++;
			//下の線
			myAry[myAryCount] = drowLine(X1+orgw,X1+orgw,Y1e,Y2e,lineW,myRegistrationColor);
			myAryCount++;
		}
	}
	//もし選択の幅と移動量が同じなら最後に線をもう一本
	if(orgw == xmovevalue){
		myAry[myAryCount] = drowLine(endx,endx,Y1,Y2,lineW,myRegistrationColor);
		myAryCount++;
		myAry[myAryCount] = drowLine(endx,endx,Y1e,Y2e,lineW,myRegistrationColor);
		myAryCount++;
	}
	//■■■■ここまで■■■■
	//■■■■ここからヨコの線を引いていく■■■■
	var X1 = orgx - 13;
	var X2 = orgx - 3;
	var X1e = endx + 13;
	var X2e = endx + 3;
	for(var Y = 0;Y < ycountvalue ;Y++){
		var Y1 = orgy + (ymovevalue * Y);
		//左の線
		myAry[myAryCount] = drowLine(X1,X2,Y1,Y1,lineW,myRegistrationColor);
		myAryCount++;
		//右の線
		myAry[myAryCount] = drowLine(X1e,X2e,Y1,Y1,lineW,myRegistrationColor);
		myAryCount++;
		//もし選択の幅と移動量が違うなら線をもう一本
		if(orgh != ymovevalue){
			//左の線
			myAry[myAryCount] = drowLine(X1,X2,Y1+orgh,Y1+orgh,lineW,myRegistrationColor);
			myAryCount++;
			//右の線
			myAry[myAryCount] = drowLine(X1e,X2e,Y1+orgh,Y1+orgh,lineW,myRegistrationColor);
			myAryCount++;
		}
	}
	if(orgh == ymovevalue){
		myAry[myAryCount] = drowLine(X1,X2,endy,endy,lineW,myRegistrationColor);
		myAryCount++;
		myAry[myAryCount] = drowLine(X1e,X2e,endy,endy,lineW,myRegistrationColor);
		myAryCount++;
	}
	app.activeWindow.activeSpread.groups.add(myAry);
}


function drowLine(X1,X2,Y1,Y2,lineW,myRegistrationColor){
	myLine=app.activeWindow.activeSpread.rectangles.add();
	myLine.paths.item(0).entirePath=[[X1,Y1],[X2,Y2]];
	//myLine.filled=false;//CS2未サポート
	//myLine.stroked=true;//CS2未サポート
	myLine.strokeWeight=lineW;
	myLine.strokeColor=myRegistrationColor;
	return myLine;
}